;(DEFADD) structure
; l                    ,  c                    ,
;6C 0E 00 00 LL HH 00 2C 63 0E 00 00 LL HH 00 2C
; w                    ,  h                    ,
;77 0E 00 00 LL HH 00 2C 68 0E 00 00 LL HH 00 2C
; a                    )
;61 0E 00 00 LL HH 00 29

#D6D8 2A0B5C   LD   HL,(#5C0B)  ;DEFADD
#D6DB 110400   LD   DE,#0004    
#D6DE 19       ADD  HL,DE       ;DEFADD+4
#D6DF 7E       LD   A,(HL)      ;lobyte l arg in A
#D6E0 1E08     LD   E,#08       
#D6E2 19       ADD  HL,DE       ;DEFADD+12
#D6E3 E5       PUSH HL          ;save lobyte c arg address
#D6E4 6E       LD   L,(HL)      ;lobyte c arg in L
#D6E5 0F       RRCA             ;}
#D6E6 0F       RRCA             ;}
#D6E7 0F       RRCA             ;}
#D6E8 4F       LD   C,A         ;
#D6E9 E603     AND  #03         
#D6EB 47       LD   B,A         
#D6EC 79       LD   A,C         
#D6ED 90       SUB  B           
#D6EE 85       ADD  A,L         
#D6EF 4F       LD   C,A         
#D6F0 78       LD   A,B         
#D6F1 C658     ADD  A,#58       
#D6F3 47       LD   B,A         
#D6F4 E1       POP  HL          ;get lobyte c arg address (DEFADD+12)
#D6F5 C5       PUSH BC          ;save start point in attributes
#D6F6 19       ADD  HL,DE       ;DEFADD+20
#D6F7 46       LD   B,(HL)      ;lobyte w arg in B
#D6F8 19       ADD  HL,DE       ;DEFADD+28
#D6F9 4E       LD   C,(HL)      ;lobyte h arg in C
#D6FA 19       ADD  HL,DE       ;DEFADD+36
#D6FB 7E       LD   A,(HL)      ;lobyte a arg in A
#D6FC E1       POP  HL          ;get start point in attributes
#D6FD C5       PUSH BC          ;save w & h
#D6FE E5       PUSH HL          ;save left-hand edge
#D6FF 77       LD   (HL),A      ;}loop to copy attributes byte
#D700 23       INC  HL          ;}to w consecutive bytes
#D701 10FC     DJNZ #D6FF       ;}
#D703 E1       POP  HL          ;restore left-hand edge
#D704 C1       POP  BC          ;get w & h in BC
#D705 1E20     LD   E,#20       
#D707 19       ADD  HL,DE       ;left-hand edge + 32 (ie. next line)
#D709 0D       DEC  C           
#D70A 20F2     JR   NZ,#D6FD    ;loop back if another line to do
#D70C C9       RET              
